[![image](https://img.shields.io/github/actions/workflow/status/juntyr/numcodecs-combinators/ci.yml?branch=main)](https://github.com/juntyr/numcodecs-combinators/actions/workflows/ci.yml?query=branch%3Amain)
[![image](https://img.shields.io/pypi/v/numcodecs-combinators.svg)](https://pypi.python.org/pypi/numcodecs-combinators)
[![image](https://img.shields.io/pypi/l/numcodecs-combinators.svg)](https://github.com/juntyr/numcodecs-combinators/blob/main/LICENSE)
[![image](https://img.shields.io/pypi/pyversions/numcodecs-combinators.svg)](https://pypi.python.org/pypi/numcodecs-combinators)
[![image](https://readthedocs.org/projects/numcodecs-combinators/badge/?version=latest)](https://numcodecs-combinators.readthedocs.io/en/latest/?badge=latest)

# numcodecs-combinators

Combinator codecs for the [`numcodecs`][numcodecs] buffer compression API.

The following combinators, implementing the [`CodecCombinatorMixin`][numcodecs_combinators.abc.CodecCombinatorMixin] are provided:

- [`CodecStack`][numcodecs_combinators.stack.CodecStack]: a stack of codecs
- [`FramedCodecStack`][numcodecs_combinators.framed.FramedCodecStack]: a stack of codecs that is framed with array data type and shape information
- [`PickBestCodec`][numcodecs_combinators.best.PickBestCodec]: pick the best codec to encode the data

## Funding

The `numcodecs-combinators` package has been developed as part of [ESiWACE3](https://www.esiwace.eu), the third phase of the Centre of Excellence in Simulation of Weather and Climate in Europe.

Funded by the European Union. This work has received funding from the European High Performance Computing Joint Undertaking (JU) under grant agreement No 101093054.
